# Cvičný zápočet z PB071: Tajné pakety

### Úvod
CIA zachytila pakety, ktoré boli zaslané Taliban-om zatiaľ neznámemu adresátovi. Keďže ste prežili 12 prednášok z PB071, tak sa prirodzene obrátili na vás, aby ste ich skontrolovali.

Pakety sa k nám ale dostali neusporiadané a dokonca je podozrenie, že teroristi nastražili vadné pakety, ktoré obsahujú spoilery z Game of Thrones. Podľa analytika majú tieto pakety chybný checksum a teda ich vieme identifikovať. Z tohto dôvodu sa **neodporúča** akokoľvek skúmať obsah vstupných súborov.

### Zadanie
Vašou úlohou je vytvoriť program, ktorý načíta, skontroluje a zoradí pakety. Potom vypíše správu, ktorá nimi bola prenášaná. Pomáhať vám bude štruktúra **secretPacket** popísaná nižšie.

### secretPacket
1. sequence_no - poradie paketu
2. source - zdrojová adresa
3. destination - cieľová adresa
4. checksum - checksum neznámeho typu - ak sa nezhoduje s vypočítaným checksumom - **paket je nevalídny**
5. payload - prenášaná správa
6. secretChecksumCalculator - funkcia, ktorá vypočíta checksum zadanej správy

### Vstupné argumenty
1.  cesta k **binárnemu** súboru, ktorý obsahuje pakety - **Povinný** argument
2.  cesta k súboru, do ktorého sa bude správa z paketov vypisovať - **Voliteľný** argument - ak nie je nastavený, tak sa použije **stdout**
3.  prepínač -v, ktorý spôsobí, že pre každý paket sa vypíše aj source a destination na riadok so správou napr. nasledujúcim spôsobom: - **Voliteľný** argument

Pozn.: poradie druhého a tretieho argumentu nie je pevne dané.

`$ ./main test -v`\
`SRC` &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;`DEST`&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;`MSG`\
`451880 456163  Ahoj`

### Očakávané chovanie
- Formát výstupu je na vás
- Očakáva sa korektná práca s pamäťou
- Vstupný súbor môže mať potenciálne **nekonečne** veľa paketov
