#ifndef SECRET_PACKET_H
#define SECRET_PACKET_H

#include <inttypes.h>

typedef struct secretPacket {
    uint16_t sequence_no;
    uint32_t source;
    uint32_t destination;
    unsigned short checksum;
    char payload[120];
} secretPacket;

// po spravnosti by to nemalo byt unsigned char, ale v kontexte zadania to nevadi :)

unsigned short secretChecksumCalculator(const unsigned char* data_p, unsigned char length){
    unsigned char x;
    unsigned short checksum = 0xFFFF;

    while (length--){
        x = checksum >> 8 ^ *data_p++;
        x ^= x >> 4;
        checksum = (checksum << 8) ^ ((unsigned short)(x << 12)) ^ ((unsigned short)(x << 5)) ^ ((unsigned short) x);
    }
    return checksum;
}

#endif // SECRET_PACKET_H