#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "secretPacket.h"

int compare (const void* a, const void* b) {
    secretPacket* packet1 = (secretPacket*) a;
    secretPacket* packet2 = (secretPacket*) b;

    if (packet1->sequence_no > packet2->sequence_no) {
        return 1;
    } else if (packet1->sequence_no == packet2->sequence_no) {
        return 0;
    }
    return -1;
}

secretPacket* getPackets(FILE* input, size_t* packetsCount) {
    size_t capacity = 4;
    secretPacket* result = malloc(capacity * sizeof(secretPacket));
    // off-by-one chyba vo while cykle, najdite si ju sami :) v pripade nejasnosti mi napiste mail
    while ((fread(result + *packetsCount, sizeof(secretPacket), 1, input)) == 1) {
        secretPacket packet = result[*packetsCount];
        if (packet.checksum != secretChecksumCalculator(packet.payload, strlen(packet.payload))) {
            continue;
        }
        (*packetsCount)++;
        if (capacity == *packetsCount) {
            capacity *= 2;
            result = realloc(result, capacity * sizeof(secretPacket));
        }    
    }

    return result;
}

int main(int argc, char** argv) {
    FILE* input = fopen(argv[1], "rb");
    if (!input) {
        perror(argv[1]);
        return 1;
    }  
    
    size_t packetsCount = 0;
    secretPacket* unorderedPackets = getPackets(input, &packetsCount);

    qsort(unorderedPackets, packetsCount, sizeof(secretPacket), compare);

    for (size_t i = 0; i < packetsCount; i++) {
        printf("%s\n", unorderedPackets[i].payload);
    }

    free(unorderedPackets);
    fclose(input);

    return 0;
}